local mPhotonView,mJavaBridge = ...
local PLAYING_GAME_LIST_SORT_KEY = "PLAYING_GAME_LIST_SORT"
local SELECTED_COLOR = "ffffd26a"
local NORMAL_COLOR = "ffffffff"
-- local NORMAL_COLOR = "ff3d3d3d"
local mGameBoxView = nil
local mGameData = nil
local mSelectedPos = 0
local mGameCount = 0
local mLastSortData = ""

function main( )
    -- 初次加载完会调用，设置一些初始值
    mGameBoxView = mPhotonView:getParser():getChildView("gamebox"):getView()
    mLastSortData = mJavaBridge:getSettingsData(PLAYING_GAME_LIST_SORT_KEY,"")
    loadGameBoxBar()
end

function loadGameBoxBar()
	local scene = mPhotonView:getParser():getBinder():get("scene")
    local sourcescene = mPhotonView:getParser():getBinder():get("sourcescene")
    local sourcesceneslotid = mPhotonView:getParser():getBinder():get("sourcesceneslotid")
    local sourcemodeltype = mPhotonView:getParser():getBinder():get("sourcemodeltype")

	-- 获取在玩
	local playGameCount =  mPhotonView:getParser():getBinder():get("playingCount")
	if playGameCount == nil then
		playGameCount = "0"
	end

	local rmdGameCount =  mPhotonView:getParser():getBinder():get("rmdGameCount")
	if rmdGameCount == nil then
		rmdGameCount = "0"
	end

    local gameViewList = {}
    local gameDataList = {}
    local gameCount = 0

    local selectedPkg =  mPhotonView:getParser():getBinder():get("selectedAppPkg")
    local mSelectedPos = 0

    for i=0, tonumber(playGameCount) - 1 do
        gameCount = gameCount + 1
        local dataTable = {}
         -- 上报数据
        dataTable["recommendid"] = 	mPhotonView:getParser():getBinder():get("playingAppRecommendId_" .. tostring(i))
        -- 应用数据
        dataTable["iconUrl"] =  mPhotonView:getParser():getBinder():get("playingIconUrl_" .. tostring(i))
        dataTable["pkgName"] =  mPhotonView:getParser():getBinder():get("playingPkgName_" .. tostring(i))
        dataTable["appName"] =  mPhotonView:getParser():getBinder():get("playingDisplayName_" .. tostring(i))
        -- 标签及分割线、选中情况
        dataTable["appTag"] = mPhotonView:getParser():getBinder():get("playingGameRemark_" .. tostring(i))
        dataTable["appTagId"] = mPhotonView:getParser():getBinder():get("playingGameRemarkId_" .. tostring(i))

        dataTable["lineVisible"] = "gone"
        dataTable["updateFn"] = updateList
        gameViewList[gameCount] = "native_gamebox_navbar_item.xml"
        gameDataList[gameCount] = dataTable
    end
    
    -- 调整在玩应用顺序
    gameDataList = sortApps(gameDataList)
    gameCount = #gameDataList

    -- 排序完成后，保存当前排序
    saveSortedApps(gameDataList)

    for i=0, tonumber(rmdGameCount) - 1 do
        gameCount  = gameCount + 1
        local dataTable = {}
        -- 上报数据
        dataTable["recommendid"] = 	    mPhotonView:getParser():getBinder():get("rmdAppRecommendId_" .. tostring(i))
        -- 应用数据
        dataTable["iconUrl"] =      mPhotonView:getParser():getBinder():get("rmdIconUrl_" .. tostring(i))
        dataTable["pkgName"] =  mPhotonView:getParser():getBinder():get("rmdPkgName_" .. tostring(i))
        dataTable["appName"] =  mPhotonView:getParser():getBinder():get("rmdDisplayName_" .. tostring(i))
        
        -- 标签及分割线、选中情况
        dataTable["appTag"] = mPhotonView:getParser():getBinder():get("rmdGameRemark_" .. tostring(i))
        dataTable["appTagId"] = mPhotonView:getParser():getBinder():get("rmdGameRemarkId_" .. tostring(i))

        dataTable["lineVisible"] = "gone"
        dataTable["updateFn"] = updateList

        if i == 0 and tonumber(playGameCount) > 0 then
            dataTable["lineVisible"] = "visible"
        end
        gameViewList[gameCount] = "native_gamebox_navbar_item.xml"
        gameDataList[gameCount] = dataTable
    end


    for i=1, gameCount do
        local dataTable = gameDataList[i]
        -- 为所有项添加上报数据、判断应用选中情况
        dataTable["scene"] =            scene
        dataTable["sourcescene"] =      sourcescene
        dataTable["sourcesceneslotid"] =  sourcesceneslotid
        dataTable["sourcemodeltype"] =  sourcemodeltype
        dataTable["subpos"] = string.format("%03d",i)

        if selectedPkg ==  dataTable["pkgName"] then
            dataTable["textColor"] = SELECTED_COLOR
            mSelectedPos = i - 1
        else
            dataTable["textColor"] = NORMAL_COLOR
        end
        if dataTable["appTagId"] ~= nil and dataTable["appTagId"] ~= "" then
            local tagHasClick = (mJavaBridge:getSettingsData("_gamebox_tag_" .. dataTable["appTagId"],"0") == "1" )
            if tagHasClick then
                dataTable["appTagId"] = ""
                dataTable["appTag"] = ""
            end
        end
    end 

    mGameData = gameDataList
    mGameCount = gameCount
    mGameBoxView:clear()
    mGameBoxView:updateData(gameViewList,mGameData)
    mGameBoxView:scrollToPosition(mSelectedPos)
    mPhotonView:getParser():getBinder():update("currentSelectedPos",mSelectedPos)
end

function onResume()
    local sortData = mJavaBridge:getSettingsData(PLAYING_GAME_LIST_SORT_KEY,"")
    if mLastSortData ~= sortData then
        -- 列表排序发生变更时，重新加载
        loadGameBoxBar()
    else
        -- 落地页的红点可能被点击过，如果列表没有重新加载，需要单独刷新红点
        refreshRedPoint()
    end
end


function sortApps(playingDataList)
    local pkgDataMap = {}
    for i=1,#playingDataList do
        local pkgName = playingDataList[i]['pkgName']
        pkgDataMap[pkgName] =  playingDataList[i]
    end

    local sortedDataList = {}
    -- 获得包名顺序列表
    local sortData = mJavaBridge:getSettingsData(PLAYING_GAME_LIST_SORT_KEY,"")
    if sortData == "" then
        return playingDataList
    end
    local sortList = splitString(sortData,",")

    for i=1,#sortList do
        local pkgName = sortList[i]
        local data = pkgDataMap[pkgName]
        -- 根据包名取应用数据，取过数据的包名置空,未取数据的说明是不在顺序列表里的
        pkgDataMap[pkgName] = nil
        if data ~= nil then
            table.insert(sortedDataList,data)
        end
    end

    for i=1,#playingDataList do
        local pkgName = playingDataList[i]['pkgName']
        local data = pkgDataMap[pkgName]
        -- 不在存储列表内的，默认为新加入游戏,插入到列表最前面
        if data ~= nil then
            table.insert(sortedDataList,1,data)
        end
    end
    return sortedDataList
end

function splitString(strInput, sep)
    if sep == nil then
            sep = "%s"
    end
    local t={} ; i=1
    for str in string.gmatch(strInput, "([^"..sep.."]+)") do
            t[i] = str
            i = i + 1
    end
    return t
end


local CHANGE_GAME_BAR_HEIGHT = 52
local BANNER_HEIGHT = mPhotonView:getParser():getScreenWidth() * 0.637
local BANNER_MARGIN_TOP = 62

function setFlatBar()
	-- 对沉浸式状态栏进行适配
	if not mJavaBridge:isFlatStyleBar() then
		return
    end
    local statusHeight = mJavaBridge:getStatusBarHeight()
    local statusHeightDp =  mJavaBridge:px2dip(statusHeight)
	local statusDp = statusHeightDp + CHANGE_GAME_BAR_HEIGHT
    local bar = mPhotonView:getParser():getChildView("change_game_bar")
    
	--  修改切换游戏栏高度
	bar:getParser():update("height",statusDp)
end

function updateList(selectIndex)
    for i=0, mGameCount -1 do
        if i == selectIndex then
            mGameBoxView:updateItemData(i,"appTag","")   
            mGameBoxView:updateItemData(i,"textColor",SELECTED_COLOR)
        else
            mGameBoxView:updateItemData(i,"textColor",NORMAL_COLOR)
        end
    end
    mJavaBridge:postRun(_notifyBarDataSetChange)
end


function refreshRedPoint()
    mJavaBridge:Log("realhe","refreshRedPoint")
    if mGameData == nil then
        return
    end

    local needRefresh = false
    for i=0, mGameCount -1 do
        local dataTable = mGameData[i + 1]
        if dataTable["appTagId"] ~= nil and dataTable["appTagId"] ~= "" then
            local tagHasClick = (mJavaBridge:getSettingsData("_gamebox_tag_" .. dataTable["appTagId"],"0") == "1" )
            if tagHasClick then
                mGameBoxView:updateItemData(i,"appTag","") 
                needRefresh = true 
            end
        end
    end

    if needRefresh then
        mJavaBridge:postRun(_notifyBarDataSetChange)
    end
end

function _notifyBarDataSetChange()
    mGameBoxView:notifyDataSetChanged()
end

function saveSortedApps(playingDataList)
    local sortListStr = ""
    for i=1,#playingDataList do
        local dataTable = playingDataList[i]
        local pkgName = dataTable['pkgName']
        if pkgName ~= nil then
            sortListStr = sortListStr .. pkgName .. ","
        end
    end
    mJavaBridge:setSettingsDataAsync(PLAYING_GAME_LIST_SORT_KEY,sortListStr)
end

function jump_all_game()
    local params = {}
    params['tmast'] = "tmast://appdemo?photonid=301536669916606&params=scene:20060,sourcescene:30029,sourcesceneslotid:31_003_00_-1"
    mPhotonView:getParser():getTaskCenter():getActionRunner():run("tmastaction",params,nil)
end